<?php

$plugin_info = array(
  'pi_name' => 'Template exists',
  'pi_version' => '1.0',
  'pi_author' => 'Denik',
  'pi_author_url' => 'http://denik.od.ua',
  'pi_description' => 'Check of template exists.',
  'pi_usage' => Tmpl_exists::usage()
);

class Tmpl_exists
{
	var $return_data = "";
  
	function Tmpl_exists()
	{
		global $TMPL, $DB, $FNS;
		
		$embed_if_exists = $TMPL->fetch_param('embed_if_exists')?true:false;
		
		$tm_in = $TMPL->fetch_param('embed_if_exists');
		if( ! $tm_in ) $tm_in = $TMPL->fetch_param('tmpl');
		$tm_in = str_replace('&#47;','/', $tm_in);
		$tm = $this->parse_tmpl($tm_in);
		
		$exists = FALSE;
		
		if( $tm !== FALSE )
		{
			/*
				$tm['site_id']
				$tm['tmpl_group']
				$tm['tmpl_name']	
			*/
			$query = $DB->query("SELECT COUNT(*) AS count FROM exp_templates AS t LEFT JOIN exp_template_groups AS tg ON t.group_id=tg.group_id WHERE tg.group_name = '{$tm['tmpl_group']}' AND t.template_name = '{$tm['tmpl_name']}' AND t.site_id = '{$tm['site_id']}' LIMIT 0,1");
			
			$exists = ($query->row['count'] >= 1) ? TRUE:FALSE;
		}
		
		// Embed if exists template
		if( $embed_if_exists )
		{
			$ret = "";
			if( $exists )
			{
				$ret = "{embed=\"$tm_in\" ".$TMPL->fetch_param('embed_params')."}";
			}
			elseif( $TMPL->fetch_param('default') )
			{
				$ret = "{embed=\"".$TMPL->fetch_param('default')."\" ".$TMPL->fetch_param('embed_params')."}";
			}
			$this->return_data = $ret;
			return;
		}
		
		// parse tagdata
		$TMPL->tagdata = str_replace(LD.'tmpl_exists'.RD, $tm_in, $TMPL->tagdata);
		$TMPL->tagdata = $FNS->prep_conditionals($TMPL->tagdata, array('tmpl_exists'=>$exists));
		
		$this->return_data = $TMPL->tagdata;
		return;
	}
	
	// Parsing tmpl variable
	function parse_tmpl($tmpl_path)
	{
		GLOBAL $PREFS, $REGX, $DB, $TMPL;

		$tmpl_path = $REGX->trim_slashes($REGX->strip_quotes($tmpl_path));

		if ( ! stristr($tmpl_path, '/'))
		{   
			return FALSE;
		}

		$ex = explode("/", trim($tmpl_path));
		
		if (count($ex) != 2)
		{
			return FALSE;
		}

		$site_id = $PREFS->ini('site_id');
		if (stristr($ex[0], ':'))
		{
			$name = substr($ex[0], 0, strpos($ex[0], ':'));
			
			if ($PREFS->ini('multiple_sites_enabled') == 'y')
			{
				$site_id = 0;
				if( sizeof($TMPL->sites) >= 0 )
				{
					$site_id = array_search($name, $TMPL->sites);
				}
				
				if( ! $site_id || $site_id==NULL )
				{
					$sites_query = $DB->query("SELECT site_id FROM exp_sites WHERE site_name='$name' LIMIT 0,1");
					if( $sites_query->num_rows > 0 )
						$site_id = $sites_query->row['site_id'];
					//else $site_id = $PREFS->ini('site_id');
				}
			}
			
			$ex[0] = str_replace($name.':', '', $ex[0]);
		}
		
		return array(
				'site_id' 		=> $site_id,	// site id
				'tmpl_group' 	=> $ex[0],		// template group
				'tmpl_name'		=> $ex[1]		// template name
			);
	}


  // ----------------------------------------
  //  Plugin Usage
  // ----------------------------------------

	function usage()
	{
	ob_start(); 
	?>
Usage example:

{exp:tmpl_exists tmpl="default_site:site/template"}
	{if tmpl_exists}
		{embed="{tmpl_exists}" id="007" param2="tmpl"}
	{if:else}
		{embed="default_site:site/not_found" id="007" param2="tmpl"}
	{/if}
{/exp:tmpl_exists}

-------------------------------------------------

Usage example with automatically generated embed tag:

{exp:tmpl_exists embed_if_exists="default_site:site/template" default="default_site:site/not_found" embed_params='id="007" param2="tmpl"'}

<?php
	$buffer = ob_get_contents();
	
	ob_end_clean(); 

	return $buffer;
	}
	// END

}
?>